#pragma once

#include "memory"
#include "json.hpp"

#include "Input.h"
#include "Output.h"

#include <Registration.h>

#include <ProcessorStandard.h>

namespace mdd {
	class Connector {

	private:
		Registration regi = Registration();
		IProcessor::Ptr _root;
		const std::map<const std::string, std::function<json(const json&)>> _ops = {//const std::map<const std::string, const json& (Connector::*)(const json&)> _ops = {
			{"add", std::bind(&Connector::add,this,std::placeholders::_1) },/*
			{"remove", std::bind(&Connector::remove,this,std::placeholders::_1)},
			{"change", std::bind(&Connector::change,this,std::placeholders::_1)},*/
			{"state", std::bind(&Connector::state,this,std::placeholders::_1)}
        };

		bool contains_subj_obj_structure(const json& args);

		/**
		*subject
		*object
		**/
		//refernece funktioniert nicht!????
		json add(const json& args);
		/**
		*subject
		*object
		**/
		json remove(const json& args);
		/**
		*subject
		*object
		**/
		json change(const json& args);
		/**
		*subject
		*object
		**/
		json state(const json& args);

	public:
		Connector();
		json decode(const json& request);
		json encode();
	};
}