#include "Connector.h"
namespace mdd {

	bool Connector::contains_subj_obj_structure(const json& args) {
		if (args.contains("object") && args.contains("subject"))
		{
			return true;
		}

		return false;
	}

	json Connector::add(const json& args) {
		json ret;
		if (!contains_subj_obj_structure(args))
		{
			return ret;
		}
		json sub = args["subject"];
		if (!sub.contains("type"))
		{
			return ret;
		}
		ret["operation"] = "add";
		json jargs;
		if (sub["type"] == "processor")
		{
			jargs["subject"] = _root->dump();
		}
		else if(sub["type"] == "module")
		{

		}
		else if (sub["type"] == "connection")
		{

		}
		else if (sub["type"] == "input")
		{

		}
		else if (sub["type"] == "output")
		{

		}
		else if (sub["type"] == "configuration")
		{

		}
		else {
			json j;
			return j;
		}

		json obj = args["object"];
		if (!obj.contains("type"))
		{
			json j;
			return j;
		}
		if (obj["type"] == "processor")
		{

		}
		else if (obj["type"] == "module")
		{
			_root->addModule(Registration().generateModule(obj["key"].get<std::string>()));
			jargs["object"] = _root->getModules().back()->dump();
		}
		else if (obj["type"] == "connection")
		{

		}
		else if (obj["type"] == "input")
		{

		}
		else if (obj["type"] == "output")
		{

		}
		else if (obj["type"] == "configuration")
		{

		}
		else {
			return ret;
		}
		ret["args"] = jargs;
		return ret;
	}

	json Connector::remove(const json& args) {

		return args;
	}

	json Connector::change(const json& args) {

		return args;
	}

	json Connector::state(const json& args) {
		json j;
		bool found = false;
		if (args == "all")
		{
			j = encode();
		}
		if (args.contains("module"))
		{
			found = true;
			if (args["module"] == "all")
			{
				
				auto modules = regi.getModules();
				for (size_t i = 0; i < modules.size(); i++)
				{
					json jmodule;
					jmodule["key"] = modules[i];
					jmodule["type"] = "module";
					j["module"].push_back(jmodule);
				}
			}
		}
		if (args.contains("processor"))
		{
			found = true;
			if (args["processor"] == "all")
			{
				auto processors = regi.getProcessors();
				for (size_t i = 0; i < processors.size(); i++)
				{
					json jprocessor;
					jprocessor["key"] = processors[i];
					jprocessor["type"] = "module";
					j["processor"].push_back(jprocessor);
				}
			}
		}
		if (!found)
		{
			j["error"] = "Reached end of state parser!";
		}
		//std::cout << "[Connector]: state: " << j.dump() << std::endl;
		json ret;
		ret["operation"] = "state";
		ret["args"] = j;
		return ret;
	}

	Connector::Connector()
	{
		_root = regi.generateProcessor("ProcessorStandard");
		_root->setName("root");
	}

	json Connector::decode(const json& request)
	{
		json ret;

		// check for correct structure
		if (!request.contains("operation") || !request.contains("args")) {
			ret["error"] = "Missing json member!";
			std::cout << "[Connector]: " << "Missing json member!" << std::endl;
			return ret;
		}
		
		auto it = _ops.find(request["operation"].get<std::string>());
		if (it != _ops.end())
		{
			ret = it->second(request["args"]);
			//std::cout << "[Connector]: " << ret.dump() << std::endl;
			return ret;
		}
		ret["error"] = "Operation is not supported!";
		return ret;
	}

	json  Connector::encode()
	{
		json ret;
		ret = _root->dump();
		std::cout << "[Connector]: encode: " << ret.dump() << std::endl;
		return ret;
	}

}

